﻿////////////////////////////////////////////////////////
//
// $DDCDriver.Name: TK_EL_SCI_ver_1
// $DDCDriver.Desc: TK_EL_SCI_ver_1
// 
// Denna driver är för Citybanan enligt 'TK EL SCI.xlsm'
//
// Dokumentet är sparat i UTF-8 för att vara compliant med JavaScript (i annat fall orsakar svenska tecken ett parsingfel)
// 
// --------------------------------------------------------------------------------------------------------------------------------
// Date     / Vers   / Sign / Comment
// --------------------------------------------------------------------------------------------------------------------------------
// 17.02.28 / 01.00  /  TR  / Main
//
//
////////////////////////////////////////////////////////

function ReadDaysFromDDC() {

  var iDayIndex;
  var iStartStopIndex;
  var sTagName;

  tsc = new TSC();

  SimulateTagRead = 1;
  SimulateTagWrite = 1;
  
  // print("NumberOnOff: " + tsc.DDCNumberOnOff);
  // print("DDCUseEvening: " + tsc.DDCUseEvening);
  // print("DDCUseHoliday: " + tsc.DDCUseHoliday);

  //WriteSomeSimulationValues();
  
  for (iDayIndex = 0; iDayIndex < (7 + 2); iDayIndex++) {

    // Mo-Fr 0..6, Evening -> Day 7, Holiday -> Day 8
    if ((iDayIndex == 7 && tsc.DDCUseEvening == 0) || (iDayIndex == 8 && tsc.DDCUseHoliday == 0)) {
      continue;
    }

    for (iStartStopIndex = 0; iStartStopIndex < tsc.DDCNumberOnOff; iStartStopIndex++) {

      sTagName = StartTagName(tsc.TagNoPar, iDayIndex, iStartStopIndex);
      sOn = TagReadInt(sTagName);
      
      if (sOn == undefined) {
        SetErrorDescription("Could not read timechannel tag '" + sTagName + "'");
        tsc.ClearDDCSchedule();
        return false;
      }

      sTagName = StopTagName(tsc.TagNoPar, iDayIndex, iStartStopIndex);
      sOff = TagReadInt(sTagName);
      
      if (sOff == undefined) {
        SetErrorDescription("Could not read timechannel tag '" + sTagName + "'");
        tsc.ClearDDCSchedule();
        return false;
      }

      // Do some fixups for PLC
      if (sOn == "2359" && sOff == "2359") {
        sOn = "0000";
        sOff = "2400";
      }
      if (sOff == "2359") {
        sOff = "2400";
      }

      tsc.SetDDCSchedule(iDayIndex, iStartStopIndex, 0, sOn);
      tsc.SetDDCSchedule(iDayIndex, iStartStopIndex, 1, sOff);
    }
  }

  return true;

}

function WriteDaysToDDC() {

  var iDayIndex;
  var iStartStopIndex;

  tsc = new TSC();

  SimulateTagRead = 1;
  SimulateTagWrite = 1;

  for (iDayIndex = 0; iDayIndex < (7 + 2); iDayIndex++) {

    // Mo-Fr 0..6, Evening -> Day 7, Holiday -> Day 8
    if ((iDayIndex == 7 && tsc.DDCUseEvening == 0) || (iDayIndex == 8 && tsc.DDCUseHoliday == 0)) {
        continue;
    }

    for (iStartStopIndex = 0; iStartStopIndex < tsc.DDCNumberOnOff; iStartStopIndex++) {

      sOn = tsc.GetDDCSchedule(iDayIndex, iStartStopIndex, 0);
      sOff = tsc.GetDDCSchedule(iDayIndex, iStartStopIndex, 1);

      // Do some fixups for PLC
      if (sOn == "0000" && sOff == "2400") {
        sOn = "2359";
        sOff = "2359";
      }
      if (sOff == "2400") {
        sOff = "2359";
      }

      sTagName = StartTagName(tsc.TagNoPar, iDayIndex, iStartStopIndex);
      if (TagWrite(sTagName, sOn) == false) {
        SetErrorDescription("Could not write timechannel tag '" + sTagName + "'");
        return false;
      }
      
      sTagName = StopTagName(tsc.TagNoPar, iDayIndex, iStartStopIndex);
      if (TagWrite(sTagName, sOff) == false) {
        SetErrorDescription("Could not write timechannel tag '" + sTagName + "'");
        return false;
      }            

    }
  }

  return true;
 
}
// SCTX-EL02-TK01-2	40303	DB100.DBW604	Starttid 1, måndag (tim_min)
// SCTX-EL02-TK01-3	40304	DB100.DBW606	Starttid 1, tisdag (tim_min)
// SCTX-EL02-TK01-4	40305	DB100.DBW608	Starttid 1, onsdag (tim_min)
// SCTX-EL02-TK01-5	40306	DB100.DBW610	Starttid 1, torsdag (tim_min)
// SCTX-EL02-TK01-6	40307	DB100.DBW612	Starttid 1, fredag (tim_min)
// SCTX-EL02-TK01-7	40308	DB100.DBW614	Starttid 1, lördag (tim_min)
// SCTX-EL02-TK01-8	40309	DB100.DBW616	Starttid 1, söndag (tim_min)
// SCTX-EL02-TK01-9	40310	DB100.DBW618	Starttid 1, helgafton (tim_min)
// SCTX-EL02-TK01-10	40311	DB100.DBW620	Starttid 1, helgdag (tim_min)
// SCTX-EL02-TK01-11	40312	DB100.DBW622	Starttid 1, specialdag 1 (tim_min)
// SCTX-EL02-TK01-12	40313	DB100.DBW624	Starttid 1, specialdag 2 (tim_min)
// SCTX-EL02-TK01-13	40314	DB100.DBW626	Starttid 1, specialdag 3 (tim_min)
// SCTX-EL02-TK01-14	40315	DB100.DBW628	Stopptid 1, måndag (tim_min)
// SCTX-EL02-TK01-15	40316	DB100.DBW630	Stopptid 1, tisdag (tim_min)
// SCTX-EL02-TK01-16	40317	DB100.DBW632	Stopptid 1, onsdag (tim_min)
// SCTX-EL02-TK01-17	40318	DB100.DBW634	Stopptid 1, torsdag (tim_min)
// SCTX-EL02-TK01-18	40319	DB100.DBW636	Stopptid 1, fredag (tim_min)
// SCTX-EL02-TK01-19	40320	DB100.DBW638	Stopptid 1, lördag (tim_min)
// SCTX-EL02-TK01-20	40321	DB100.DBW640	Stopptid 1, söndag (tim_min)
// SCTX-EL02-TK01-21	40322	DB100.DBW642	Stopptid 1, helgafton (tim_min)
// SCTX-EL02-TK01-22	40323	DB100.DBW644	Stopptid 1, helgdag (tim_min)
// SCTX-EL02-TK01-23	40324	DB100.DBW646	Stopptid 1, specialdag 1 (tim_min)
// SCTX-EL02-TK01-24	40325	DB100.DBW648	Stopptid 1, specialdag 2 (tim_min)
// SCTX-EL02-TK01-25	40326	DB100.DBW650	Stopptid 1, specialdag 3 (tim_min)
// SCTX-EL02-TK01-26	40327	DB100.DBW652	Starttid 2, måndag (tim_min)
// SCTX-EL02-TK01-27	40328	DB100.DBW654	Starttid 2, tisdag (tim_min)
// SCTX-EL02-TK01-28	40329	DB100.DBW656	Starttid 2, onsdag (tim_min)
// SCTX-EL02-TK01-29	40330	DB100.DBW658	Starttid 2, torsdag (tim_min)
// SCTX-EL02-TK01-30	40331	DB100.DBW660	Starttid 2, fredag (tim_min)
// SCTX-EL02-TK01-31	40332	DB100.DBW662	Starttid 2, lördag (tim_min)
// SCTX-EL02-TK01-32	40333	DB100.DBW664	Starttid 2, söndag (tim_min)
// SCTX-EL02-TK01-33	40334	DB100.DBW666	Starttid 2, helgafton (tim_min)
// SCTX-EL02-TK01-34	40335	DB100.DBW668	Starttid 2, helgdag (tim_min)
// SCTX-EL02-TK01-38	40339	DB100.DBW676	Stopptid 2, måndag (tim_min)
// SCTX-EL02-TK01-39	40340	DB100.DBW678	Stopptid 2, tisdag (tim_min)
// SCTX-EL02-TK01-40	40341	DB100.DBW680	Stopptid 2, onsdag (tim_min)
// SCTX-EL02-TK01-41	40342	DB100.DBW682	Stopptid 2, torsdag (tim_min)
// SCTX-EL02-TK01-42	40343	DB100.DBW684	Stopptid 2, fredag (tim_min)
// SCTX-EL02-TK01-43	40344	DB100.DBW686	Stopptid 2, lördag (tim_min)
// SCTX-EL02-TK01-44	40345	DB100.DBW688	Stopptid 2, söndag (tim_min)
// SCTX-EL02-TK01-45	40346	DB100.DBW690	Stopptid 2, helgafton (tim_min)
// SCTX-EL02-TK01-46	40347	DB100.DBW692	Stopptid 2, helgdag (tim_min)

function StartTagName(sTagNoPar, iDayIndex, iStartStopIndex) {

  var sTagName;
  var iTK;
	
  iTK = iDayIndex + iStartStopIndex * 24 + 2;

  sTagName = tsc.TagNoPar + "-" + iTK + ".F";

  return sTagName;

}

function StopTagName(sTagNoPar, iDayIndex, iStartStopIndex) {

  var sTagName;
  var iTK;

  iTK = iDayIndex + iStartStopIndex * 24 + 14;

  sTagName = tsc.TagNoPar + "-" + iTK + ".F";

  return sTagName;

}

//
// EDA/iFix seem to have problem using floats in database with SIM-driver, ex
//
// 2105 reads as 2105.01
// 2106 reads as 2105.98
//
function TagReadInt(sTagName) {

  var iValue = TagRead(sTagName);
  
  if (iValue == undefined) {
    return iValue;
  }

  // We need to cast iValue to Float (instead of string) first, add 0,5 and then make an int of it
  iValue = parseInt(parseFloat(iValue) + 0.5);
  
  // Do some sanity check
  if (iValue < 0) {
    iValue = 0;
  }
  if (iValue > 2400) {
    iValue = 2400;
  }
  
  return iValue;
  
}

function WriteSomeSimulationValues() {

  var iDayIndex;
  var iStartStopIndex;
  
  // We don't want these values to be written to PLC...
  SimulateTagWrite = 1;
  
  for (iDayIndex = 0; iDayIndex < (7 + 2); iDayIndex++) {

    // Mo-Fr 0..6, Evening -> Day 7, Holiday -> Day 8
    if ((iDayIndex == 7 && tsc.DDCUseEvening == 0) || (iDayIndex == 8 && tsc.DDCUseHoliday == 0)) {
        continue;
    }

    for (iStartStopIndex = 0; iStartStopIndex < tsc.DDCNumberOnOff; iStartStopIndex++) {

      sTagName = StartTagName(tsc.TagNoPar, iDayIndex, iStartStopIndex);
      // print("sTagName Start (iDayIndex: " + iDayIndex + ") (iStartStopIndex: " + iStartStopIndex + "): " + sTagName);
      TagWrite(sTagName, iStartStopIndex * 1100 + iDayIndex);

      sTagName = StopTagName(tsc.TagNoPar, iDayIndex, iStartStopIndex);
      // print("sTagName Stop (iDayIndex: " + iDayIndex + ") (iStartStopIndex: " + iStartStopIndex + "): " + sTagName);
      TagWrite(sTagName, 1000 + iStartStopIndex * 1100 + iDayIndex);

    }
  }
}